﻿<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <!--

    Циклическая конструкция - do-while. 

    Факториал числа n (обозначается n!, произносится - эн факториал) — это произведение 
    всех натуральных чисел,
    от 1 до n включительно:
        n! = 1 * 2 * 3 * ... * n
        0! = 1

    В комбинаторике факториал натурального числа n интерпретируется как количество 
    перестановок множества из n элементов. Например, для множества {A,B,C,D} 
    из 4-х элементов существует: 4! = 1 * 2 * 3 * 4 = 24 перестановки:

        ABCD  BACD  CABD  DABC
        ABDC  BADC  CADB  DACB
        ACBD  BCAD  CBAD  DBAC
        ACDB  BCDA  CBDA  DBCA
        ADBC  BDAC  CDAB  DCAB
        ADCB  BDCA  CDBA  DCBA

-->
<script type="text/javascript">


/*  
  
    let counter = 0;

    do {
        document.write(counter + "<br />");
        counter++;
    } while (counter < 10);
 */
 
    let counter = prompt("Введите число");
    let factorial = 1;

    document.write("Факториал числа: " + counter + "! = ");

    do {

        if (counter == 0) {
            factorial = 1;
            break;
        }

        factorial = factorial * counter;
        counter = counter - 1;
    }
    while (counter > 1);

    document.write(factorial);



</script>

</body>
</html>